#include <QPushButton>
#include <QMessageBox>
#include <QApplication>
#include <QWidget>
#include <QPushButton>
#include <QGridLayout>
#include <QGroupBox>
#include <QLabel>
#include <QComboBox>
#include <QPlainTextEdit>
#include <QLineEdit>
#include <QStringList>
#include <QTreeWidgetItem>
#include <iostream>
#include <QProgressBar>
#include <QMap>
#include <QVector>
#include "xmlParser.h"
#include "description.h"

Description::Description()
{
  xml = new XmlParser;
  tab[0] = new QLabel;
  tab[1] = new QLabel("Types :");
  tab[2] = new QLabel;
  tab[3] = new QLabel;
  tab[4] = new QLabel;
  tab[5] = new QLabel;
  tab[6] = new QLabel;
  tab[7] = new QLabel;
  tab[8] = new QLabel("Description : ");
  att = new QLabel("Moves : ");
  eg = new QLabel("Egg Moves : ");
  evol = new QLabel("Evolutions : ");
  descriptionBox = new QGroupBox;
  description = new QPlainTextEdit;
  evolution = new QPlainTextEdit;
  attack = new QPlainTextEdit;
  egg = new QPlainTextEdit;
  layout = new QGridLayout;
  image = new QLabel;
  stat["HP"] = new QProgressBar;
  stat["ATK"] = new QProgressBar;
  stat["DEF"] = new QProgressBar;
  stat["SPD"] = new QProgressBar;
  stat["SAT"] = new QProgressBar;
  stat["SDF"] = new QProgressBar;
}

Description::~Description()
{
  delete xml;
  delete tab[0];
  delete tab[1];
  delete tab[2];
  delete tab[3];
  delete tab[4];
  delete tab[5];
  delete tab[6];
  delete tab[7];
  delete tab[8];
  delete descriptionBox;
  delete att;
  delete eg;
  delete evol;
  delete description;
  delete evolution;
  delete attack;
  delete egg;
  delete layout;
  delete image;
  delete stat["HP"];
  delete stat["ATK"];
  delete stat["DEF"];
  delete stat["SPD"];
  delete stat["SAT"];
  delete stat["SDF"];
}

void	Description::doStats(int x)
{
  int bk = x;
  char tab[6][4] = {"HP", "ATK", "DEF", "SPD", "SAT", "SDF"};
  char tab2[6][12] = {"HP", "ATTACK", "DEFENSE", "SPEED", "SPE ATTACK", "SPE DEFENSE"};
  QMap<QString, QProgressBar *>::iterator it = this->stat.begin();
  while (it != this->stat.end())
    {
      (*it)->setMaximum(160);
      (*it)->setFormat(tab2[x - bk] + QString(": ") + this->info[tab[x - bk]]);
      (*it)->setValue(this->info[tab[x - bk]].toUInt());
      this->layout->addWidget((*it), x, 0, 1, 4);
      it++;
      x++;
    }
}

void Description::display(QString pokemonName, QGridLayout *grille)
{
  this->xml->getInfos(pokemonName);
  this->info = this->xml->getMap();
  this->tab[0]->setText("Name : " + this->info["name"]);
  this->path = "images/" + this->info["type1"] + ".png";
  this->descriptionBox->setTitle("Pokemon Description");
  this->tab[2]->setPixmap(QPixmap(this->path));
  this->path = "images/" + this->info["type2"] + ".png";
  this->tab[3]->setPixmap(QPixmap(this->path));
  this->tab[4]->setText("Ability : " + info["ability"]);
  this->tab[5]->setText("Species : " + info["species"]);
  this->tab[6]->setText("Height : " + info["height"]);
  this->tab[7]->setText("Weight : " + info["weight"]);
  this->description->setPlainText(info["description"]);
  this->description->setReadOnly(true);
  this->attack->setPlainText(xml->getAttacks());
  this->attack->setReadOnly(true);
  if (xml->getEggs() != "")
    this->egg->setPlainText(xml->getEggs());
  else
    this->egg->setPlainText("This Pokemon does not learn any egg moves.");
  this->egg->setReadOnly(true);
  
  int j = 0;
  QMap<int, QLabel *>::iterator It = this->tab.begin();
  while (It != this->tab.end())
    {
      this->layout->addWidget((*It), j, 0);
      j++;
      It++;
    }
  this->evolution->setPlainText(this->xml->getEvo());
  this->evolution->setReadOnly(true);
  this->layout->addWidget(description, j, 0, 1, 1);
  this->layout->addWidget(evol, j - 1, 1);
  this->layout->addWidget(evolution, j, 1, 1, 1);
  j++;
  this->layout->addWidget(this->att, j, 0);
  this->layout->addWidget(this->eg, j, 1);
  j++;
  this->layout->addWidget(this->attack, j, 0, 1, 1);
  this->layout->addWidget(this->egg, j, 1, 1, 1);
  j++;
  this->path = "images/" + this->info["id"] + ".png";
  this->image->setPixmap(QPixmap(this->path));
  this->layout->addWidget(this->image, 0, 1, 7, 3);
  this->doStats(j);
  this->descriptionBox->setLayout(this->layout);
  grille->addWidget(descriptionBox, 0, 5, 8, 6);
}
