#include "teamWindow.h"

TeamWindow::TeamWindow() : QWidget()
{
  teamName = new QLineEdit;
  path = new QString("avatar.jpg");
  nameForm = new  QLineEdit;
  owner = new QLabel("USER");
  avatar = new QLabel("AVATAR");
  teamList = new QTreeWidget;
  pokemonList = new QTreeWidget;
  pokemonList->setHeaderLabel("Pokemon List of this Team");
  teamList->setHeaderLabel("Your Team List");
  grille = new QGridLayout;
  exit = new QPushButton("QUIT", this);
  ok = new QPushButton("Change Name", this);
  add = new QPushButton("Create Team", this);
  imageAdd = new QPushButton("Choose Avatar", this);
  descriptionBox = new TeamDescription;

  teamPopup = new QFrame(this, Qt::Popup | Qt::Window );
  ask = new QLabel("How do you want to name your team ?\n", teamPopup);
  tPopLayout = new QGridLayout;
  tPopOk = new QPushButton("Add");
  grille->addWidget(exit, 9, 4);
  tPopLayout->addWidget(ask, 0, 0);
  tPopLayout->addWidget(teamName, 1, 0);
  tPopLayout->addWidget(tPopOk, 1, 1);
  teamPopup->move(width() / 2 - 150, height() / 2 - 100);
  teamPopup->setLayout(tPopLayout);

  namePopup = new QFrame(this, Qt::Popup | Qt::Window );
  nameAsk = new QLabel("How do you want you to be called ?\n", namePopup);
  nPopLayout = new QGridLayout;
  nPopOk = new QPushButton("Change");
  nPopLayout->addWidget(nameAsk, 0, 0);
  nPopLayout->addWidget(nameForm, 1, 0);
  nPopLayout->addWidget(nPopOk, 1, 1);
  namePopup->move(width() / 2 - 150, height() / 2 - 100);
  namePopup->setLayout(nPopLayout);

  xml = new xmlManager("test.xml");
  xml->addElem("PokemonTeam");
  xml->addElem("Leader", "PokemonTeam");
  xml->addElem("Name|User", "Leader");
  xml->addElem("Image|/images/1.png", "Leader");
  xml->addElemId("Teams", "Nb|0", "Leader");
  display();
  descriptionBox->display(this->grille);
  QObject::connect(exit, SIGNAL(clicked()), qApp, SLOT(quit()));
}

TeamWindow::~TeamWindow()
{
  xml->writeXml();
  delete teamName;
  delete path;
  delete nameForm;
  delete owner;
  delete avatar;
  delete teamList;
  delete pokemonList;
  delete grille;
  delete exit;
  delete ok;
  delete add;
  delete imageAdd;
  delete xml;
}

void TeamWindow::uploadAvatar()
{
  this->file = QFileDialog::getOpenFileName(this, "Ouvrir un fichier", QString(), "Images (*.png *.gif *.jpg *.jpeg)");
  if (!(this->file.isEmpty()))
    this->avatar->setPixmap(QPixmap(this->file));
}

void TeamWindow::addTeam()
{
  QString team = this->teamName->text();
  std::cout << "HERE\n";
  this->xml->addElemId("Team", "Id|0", "PokemonTeam");
  this->xml->addElem("Name|" + team, "Team");
  if (team.count() > 0)
    {
      this->teams.append(new QTreeWidgetItem(QStringList(team)));
      this->teamList->insertTopLevelItems(0, this->teams);
      this->teamName->clear();
      this->teamPopup->hide();
    }
}

void TeamWindow::teamAdder()
{
  this->teamName->setFocus();
  this->teamPopup->show();
  QObject::connect(this->tPopOk, SIGNAL(clicked()), this, SLOT(addTeam()));
  QObject::connect(this->teamName, SIGNAL(returnPressed()), this, SLOT(addTeam()));
}

void TeamWindow::nameChange()
{
  if (!(this->nameForm->text().isEmpty()))
    {
      this->owner->setText(this->nameForm->text());
      //this->xml->modifElem("PokemonTeam", "");
    }
  this->namePopup->hide();
}

void TeamWindow::nameChanger()
{
  this->namePopup->show();
  this->nameForm->setFocus();
  QObject::connect(this->nPopOk, SIGNAL(clicked()), this, SLOT(nameChange()));
  QObject::connect(this->nameForm, SIGNAL(returnPressed()), this, SLOT(nameChange()));
}

void	TeamWindow::display()
{
  this->grille->addWidget(this->imageAdd, 0, 0);
  this->grille->addWidget(this->ok, 0, 1);
  this->grille->addWidget(this->add, 1, 1);
  this->grille->addWidget(this->teamList, 3, 0, 1, 2);
  QObject::connect(this->ok, SIGNAL(clicked()), this, SLOT(nameChanger()));
  QObject::connect(this->add, SIGNAL(clicked()), this, SLOT(teamAdder()));
  QObject::connect(this->imageAdd, SIGNAL(clicked()), this, SLOT(uploadAvatar()));
  this->grille->addWidget(this->pokemonList, 3, 2, 2, 3);
  this->grille->addWidget(this->owner, 1, 3);
  this->grille->addWidget(this->avatar, 0, 4, 3, 1);
}

QGridLayout *TeamWindow::getGrille()
{
  return this->grille;
}
