#ifndef __TEAMWINDOW__
#define __TEAMWINDOW__

#include <QApplication>
#include <QWidget>
#include <QLineEdit>
#include <QTreeWidget>
#include <QGridLayout>
#include <QLabel>
#include <QString>
#include <QPushButton>
#include <QFileDialog>

#include "teamDescription.h"
#include "xmlCreator.h"
#include "xmlManager.h"

class TeamWindow : public QWidget
{
  Q_OBJECT;
 public:
  TeamWindow();
  ~TeamWindow();
  void	display();
  QGridLayout *getGrille();
 public slots:
  void teamAdder();
  void addTeam();
  void nameChanger();
  void nameChange();
  void uploadAvatar();
 private:
  TeamDescription *descriptionBox;
  QLineEdit *teamName;
  QPushButton *imageAdd;
  QString file;
  QLabel *owner;
  QLabel *avatar;
  QString *path;
  QList<QTreeWidgetItem*> teams;
  QTreeWidget *teamList;
  QTreeWidget *pokemonList;
  QGridLayout *grille;
  QPushButton *exit;
  QPushButton *ok;
  QPushButton *add;
  QFrame* teamPopup;
  QLabel* ask;
  QGridLayout *tPopLayout;
  QPushButton *tPopOk;

  QFrame* namePopup;
  QLabel* nameAsk;
  QGridLayout *nPopLayout;
  QPushButton *nPopOk;
  QLineEdit *nameForm;
  QTreeWidget	*treeTeam;
  xmlManager *xml;
};

#endif
