#include "window.h"

void Window::find(QTreeWidgetItem *item, int column)
{
  this->pokemonName = item->text(column);
  if (this->descriptionBox != NULL)
    {
      this->grille->removeWidget(descriptionBox);
      this->descriptionBox->hide();
    }
  this->description->display(this->pokemonName, this->grille);
}

void Window::teamer(QTreeWidgetItem *item, int column)
{
  QFrame* popup1 = new QFrame(this, Qt::Popup | Qt::Window );
  QLabel* ask = new QLabel("To which team do you want to add " + item->text(column) + " ?\n", popup1);
  QGridLayout *layout = new QGridLayout;
  QComboBox *teams = new QComboBox(popup1);
  teams->addItem("TEAMS");
  teams->addItem(item->text(column));
  layout->addWidget(ask, 0, 0);
  layout->addWidget(teams, 1, 0);
  popup1->move(this->width() / 2 - 150, this->height() / 2 - 100);
  popup1->setLayout(layout);
  popup1->show();
  XmlCreator *test = new XmlCreator;
  test->initialise();
}

void Window::search(QString name)
{
  QVector<QString> results;
  XmlParser *xml = new XmlParser;
  if (name.count() > 0)
    results = xml->search(name, true);
  else
    results = xml->search(name, false);
  QList<QTreeWidgetItem *> items;
  treeWidget = new QTreeWidget();
  treeWidget->setColumnCount(1);
  treeWidget->setHeaderLabel("Name of the Pokemon");
  for (int i = 0; results[i] != ""; i++)
    items.append(new QTreeWidgetItem(QStringList(results[i])));
  this->treeWidget->insertTopLevelItems(0, items);
  layout->addWidget(treeWidget, 3, 0, 5, 4);
  QObject::connect(treeWidget, SIGNAL(itemClicked(QTreeWidgetItem *, int)), this, SLOT(find(QTreeWidgetItem *, int)));
  QObject::connect(treeWidget, SIGNAL(itemDoubleClicked(QTreeWidgetItem *, int)), this, SLOT(teamer(QTreeWidgetItem *, int)));
}

void	Window::searchPart()
{
  QGroupBox *box = new QGroupBox("Pokemon Search", this);
  QLabel *name = new QLabel("Name:");
  nameForm = new QLineEdit;
  this->layout = new QGridLayout;
  layout->addWidget(name, 0, 0);
  layout->addWidget(nameForm, 0, 1);
  treeWidget = new QTreeWidget();
  treeWidget->setColumnCount(1);
  treeWidget->setHeaderLabel("Name of the Pokemon");
  layout->addWidget(treeWidget, 3, 0, 5, 4);
  box->setLayout(layout);
  grille->addWidget(box, 0, 0, 8, 2);
}

Window::Window() : QWidget()
{
  grille = new QGridLayout;
  descriptionBox = NULL;
  description = new Description;
  searchPart();
  search("");

  exit = new QPushButton("QUIT", this);
  grille->addWidget(exit, 8, 10);
  description->display("BULBASAUR", grille);
  QObject::connect(exit, SIGNAL(clicked()), qApp, SLOT(quit()));
  QObject::connect(nameForm, SIGNAL(textChanged(QString)), this, SLOT(search(QString)));
  QObject::connect(treeWidget, SIGNAL(itemActivated(QTreeWidgetItem *, int)), this, SLOT(find(QTreeWidgetItem *, int)));
}

Window::~Window()
{
  delete exit;
  delete grille;
  delete layout;
  delete nameForm;
  delete descriptionBox;
  delete treeWidget;
}

QGridLayout *Window::getGrille()
{
  return (this->grille);
}
