#include <QString>
#include <QList>

#include "xmlElement.h"

xmlElement::xmlElement()
{
}

xmlElement::xmlElement(QString _nodeName,
		       QString _nodeValue, QString _idName, QString _idValue)
{
  nodeName = _nodeName;
  nodeValue = _nodeValue;
  idName = _idName;
  idValue = _idValue;
  children = new QList<xmlElement>;
}

xmlElement::~xmlElement()
{
}

xmlElement::xmlElement(const xmlElement& in)
{
  *this = in;
}

xmlElement&	xmlElement::operator=(const xmlElement& in)
{
  if (this != &in)
    {
      this->nodeName = in.nodeName;
      this->nodeValue = in.nodeValue;
      this->idName = in.idName;
      this->idValue = in.idValue;
      //this->father = in.father;
      this->children = in.children;
    }
  return *this;
}

void	xmlElement::setNodeName(const QString _nodeName)
{
  this->nodeName = _nodeName;
}

void	xmlElement::setNodeValue(const QString _nodeValue)
{
  this->nodeValue = _nodeValue;
}

void	xmlElement::setIdName(const QString _idName)
{
  this->idName = _idName;
}

void	xmlElement::setIdValue(const QString _idValue)
{
  this->idValue = _idValue;
}

// void	xmlElement::setFather(const QList<xmlElement> _father)
// {
//   this->father = _father;
// }

void	xmlElement::setChildren(QList<xmlElement> *_children)
{
  this->children = _children;
}

QString	xmlElement::getNodeName() const
{
  return this->nodeName;
}

QString	xmlElement::getNodeValue() const
{
  return this->nodeValue;
}

QString	xmlElement::getIdName() const
{
  return this->idName;
}

QString	xmlElement::getIdValue() const
{
  return this->idValue;
}

// QList<xmlElement>	xmlElement::getFather() const
// {
//   return this->father;
// }

QList<xmlElement>	*xmlElement::getChildren() const
{
  return this->children;
}
