#include <iostream>
#include <QDomDocument>
#include <QVector>
#include <QTextStream>
#include <QString>
#include <QList>
#include <QFile>

#include "xmlElement.h"
#include "xmlManager.h"

static	QVector<QString> my_explode(const char sep, const QString element)
{
  int i = 0;
  int bk = 0;
  QVector<QString> vector(0);

 // while (element[i] != sep)
  //{
//	  if (i < element.size())
	//	i = i + 1;
	  //else
	//	break;
  //}
  vector.append(element.left(i));
  bk = ++i;
  while (i != element.length())
    i++;
  vector.append(element.mid(bk, i));
  return vector;
}

static void	insertElem(xmlElement element,
			   QList<xmlElement> *list, QString father)
{
  QList<xmlElement>::iterator it = list->begin();

  while (it != list->end())
    {
      if ((*it).getNodeName() == father)
	{
	  (*it).getChildren()->push_back(element);
  	  return;
	}
      else if (!(*it).getChildren()->isEmpty())
	insertElem(element, (*it).getChildren(), father);
      it++;
    }
}

static void	insertDomDocument(QDomDocument doc,
				  QDomElement nodeRoot, QList<xmlElement> *list)
{
  QDomElement	nodeCurrent;
  QList<xmlElement>::iterator it = list->begin();

  while (it != list->end())
    {
      nodeCurrent = doc.createElement((*it).getNodeName());
      if ((*it).getNodeValue() != "")
	nodeCurrent.appendChild(doc.createTextNode((*it).getNodeValue()));
      if ((*it).getIdName() != "")
	nodeCurrent.setAttribute((*it).getIdName(), (*it).getIdValue());
      nodeRoot.appendChild(nodeCurrent);
      if (!(*it).getChildren()->isEmpty())
	insertDomDocument(doc, nodeCurrent, (*it).getChildren());
      it++;
    }
}

xmlManager::xmlManager()
{
}

xmlManager::xmlManager(QString _xmlFileName)
{
  xmlFileName = _xmlFileName;
}

xmlManager::~xmlManager()
{
}

xmlManager::xmlManager(xmlManager &in)
{
  *this = in;
}

xmlManager&       xmlManager::operator=(xmlManager &in)
{
  if (this != &in)
    {
      this->xmlFileName = in.xmlFileName;
      this->list = in.list;
    }
  return *this;
}

void	xmlManager::addElem(const QString node,
			    const QString father)
{
  QVector<QString> tmpNode = my_explode('|', node);

  xmlElement tmp(tmpNode[0], tmpNode[1]);
  if (father.isNull())
    this->list.push_back(tmp);
  else
    insertElem(tmp, &this->list, father);
}

void	xmlManager::addElemId(const QString node,
			      const QString id, QString father)
{
  QVector<QString> tmpNode = my_explode('|', node);
  QVector<QString> tmpId = my_explode('|', id);

  xmlElement tmp(tmpNode[0], tmpNode[1], tmpId[0], tmpId[1]);
  if (father.isNull())
    this->list.push_back(tmp);
  else
    insertElem(tmp, &this->list, father);
}

void	xmlManager::writeXml()	const
{
  QDomDocument	doc(this->xmlFileName);
  QFile		file(this->xmlFileName);
  QTextStream	stream;
  QDomElement	root;
  QList<xmlElement>::const_iterator it = this->list.begin();

  while (it != this->list.end())
    {
      root = doc.createElement((*it).getNodeName());
      if ((*it).getNodeValue() != "")
	root.appendChild(doc.createTextNode((*it).getNodeValue()));
      if ((*it).getIdName() != "")
	root.setAttribute((*it).getIdName(), (*it).getIdValue());
      doc.appendChild(root);
      if (!(*it).getChildren()->isEmpty())
	insertDomDocument(doc, root, (*it).getChildren());
      it++;
    }
  file.open(QIODevice::WriteOnly);
  stream.setDevice(&file);
  stream << doc;
  file.close();
}

// void	xmlManager::readXml(const QString _xmlFileName)
// {
//   QFile		file(_xmlFileName);
//   QString	nodeName;
//   QString	nodeId;
//   QDomDocument	doc;
//   QDomNode	rootNode;
//   QDomElement	element;

//   if (!file.open(QIODevice::ReadOnly))
//     return;
//   if (!doc.setContent(&file))
//     {
//       file.close();
//       return;
//     }
//   // rootNode = doc.documentElement();
//   rootNode = (doc.documentElement()).firstChild();
//   //  childNode = rootNode.firstChild();
//   while (!rootNode.isNull())
//     {
//       //      element = rootNode.toElement();
//       nodeName = (rootNode.toElement()).tagName() + '|' + (rootNode.toText()).data();
//       std::cout << qPrintable(nodeName) << std::endl;
//       std::cout << "attr = " << qPrintable(rootNode.toElement().getAttribute()) << std::endl;
//       rootNode = rootNode.nextSibling();
//     }
//   file.close();
// }
