#include "xmlParser.h"

XmlParser::~XmlParser()
{
}

XmlParser::XmlParser()
{
  results.resize(494);
  QFile f("pokedata.xml");
  f.open(QIODevice::ReadOnly);
  doc.setContent(&f);
  root = this->doc.documentElement();
}

QVector<QString> XmlParser::search(QString name, bool flag)
{
  child = this->root.firstChild().toElement();
  int i = 0;
  while(!child.isNull())
    {
      if (child.tagName() == "pokemon")
	{
	  gChild = child.firstChild().toElement();
	  while(!gChild.isNull())
	    {
	      if (gChild.tagName() == "name" && (gChild.text().contains(name, Qt::CaseInsensitive) ||
						 (flag == false)))
		{
		  results[i] = gChild.text();
		  i++;
		}
	      gChild = gChild.nextSibling().toElement();
	    }
	}
      child = child.nextSibling().toElement();
    }
  f.close();
  results[i] = "";
  return results;
}

void XmlParser::getInfos(QString name)
{
  bool flag = false;
  child = this->root.firstChild().toElement();
  this->eggs.remove(0, this->eggs.count());
  this->evo.remove(0, this->evo.count());
  while(!child.isNull())
    {
      if (child.tagName() == "pokemon")
	{	
	  int index = 0;
	  QString id = child.attribute("id");
	  gChild = child.firstChild().toElement();
	  while(!gChild.isNull())
	    {
	      if (gChild.text() == name)
		{
		  while(!gChild.isNull())
		    {
		      this->infos["id"] = id;
		      if (gChild.tagName() == "type" && flag == false)
			{
			  this->infos["type1"] = gChild.text();
			  this->infos["type2"] = "Aucun";
			  flag = true;
			}
		      else if (gChild.tagName() == "type" && flag == true)
			this->infos["type2"] = gChild.text();
		      else if (gChild.tagName() == "stats")
			{
			  ggChild = gChild.firstChild().toElement();
			  while(!ggChild.isNull())
			    {
			      this->infos[ggChild.tagName()] = ggChild.text();
			      ggChild = ggChild.nextSibling().toElement();
			    }
			}
		      else if (gChild.tagName() == "evolutions")
			{
			  ggChild = gChild.firstChild().toElement();
			  while(!ggChild.isNull())
			    {
			      gggChild = ggChild.firstChild().toElement();
			      while(!gggChild.isNull())
				{
				  this->evo.push_back(gggChild.text());
				  gggChild = gggChild.nextSibling().toElement();
				}
			      ggChild = ggChild.nextSibling().toElement();
			    }
			}
		      else if (gChild.tagName() == "moves")
			{
			  ggChild = gChild.firstChild().toElement();
			  while(!ggChild.isNull())
			    {
			      gggChild = ggChild.firstChild().toElement();
			      if (ggChild.attribute("type") == "level-up")
				while(!gggChild.isNull())
				  {
				    this->attacks.insert(index, gggChild.text());
				    gggChild = gggChild.nextSibling().toElement();
				    index++;
				  }
			      else if (ggChild.attribute("type") == "egg")
				{
				  this->eggs.push_back(ggChild.firstChild().toElement().text());
				}
			      ggChild = ggChild.nextSibling().toElement();
			    }
			}
		      else
			this->infos[gChild.tagName()] = gChild.text();
		      gChild = gChild.nextSibling().toElement();
		    }
		}
	      else
		gChild = gChild.nextSibling().toElement();
	    }
	}
      child = child.nextSibling().toElement();
    }
  f.close();
}

QMap<QString, QString> XmlParser::getMap()
{
  return this->infos;
}

QString XmlParser::getAttacks()
{
  QString final("");
  QString tmp("");
  
  for (int i = 0; i < this->attacks.count(); i++)
    {
      if (i % 2 == 0)
	tmp = this->attacks.value(i);
      else
	final += this->attacks.value(i) + "\t" + tmp;
      if (i % 2 == 0 && i != 0)
	final += "\n";
    }
  return final;
}

QString XmlParser::getEvo()
{
  QString final("");
  QString tmp("");
  
  final += "1\t";
  for (int i = 0; i < this->evo.count(); i++)
    {
      if (i % 2 != 0)
	tmp = this->evo.value(i);
      else
	final += this->evo.value(i) + "\t" + tmp;
      if (i % 2 != 0 && i != 0)
	final += "\n";
    }
  return final;
}

QString XmlParser::getEggs()
{
  QString final("");
  for (int i = 0; i < this->eggs.count(); i++)
    {
      final += this->eggs[i] + "\n";
    }
  return final;
}
